
# __revision__  = $LastChangedRevision$
# __Copyright__ = Copyright (c) 2007 - 2009, CollabNet, Inc. All rights reserved.

import sys

Commands = {}
ApiMethods = {}
SoapApps = {}

def importModule(pkgname, modname=None):
    try:
        if modname:
            module = __import__('%s' % pkgname, globals(), locals(), [modname])
        else:
            module = __import__('%s' % pkgname, globals(), locals(), [])
    except ImportError, e:
        print "ERROR: could not import module '%s/%s'" % (pkgname, modname)
        print "ERROR: errmsg: %s" % e
        print "NOTE : this may not be a fatal error, but certain commands won't work"
        return
    if modname:
        mod = getattr(module, modname)
        sys.modules[mod.__name__] = mod
    if modname:
        return mod
    else:
        return module

def mapCommands(pkgname, sub=None):
    if sub:
        m = importModule(pkgname, sub)
    else:
        m = importModule(pkgname)
    if hasattr(m, '__all__'):
        for s in m.__all__:
            mapCommands(m.__name__, s)
    else:
        if hasattr(m, 'commands'):
            # add all listed commands into Commands dictionary
            for c in m.commands:
                Commands[c] = getattr(m, c)
        if hasattr(m, 'Services') and hasattr(m, 'SoapApp'):
            SoapApps[m.SoapApp] = m.Services
            # add all listed commands into Commands dictionary
            for s in m.Services:
                ApiMethods[s] = getattr(m, m.SoapApp)
    return (Commands, SoapApps, ApiMethods)

(Commands, SoapApps, ApiMethods) = mapCommands('Services')
