
# __revision__  = $LastChangedRevision$
# __Copyright__ = Copyright (c) 2007 - 2009, CollabNet, Inc. All rights reserved.

import sys

class SimpleLog(object):
    """Log messages to the stderr at various log levels. From least to most
       verbose, the available log levels are:
           ERROR, WARN, INFO, VERBOSE, DEBUG, DEBUG1, DEBUG2, DEBUG3, DEBUG4, DEBUG5.
    """

    def __init__(self, level, logfile=sys.stderr):
        self.level = level
        self.loglevel = {
                        'DEBUG5'  : 45,
                        'DEBUG4'  : 44,
                        'DEBUG3'  : 43,
                        'DEBUG2'  : 42,
                        'DEBUG1'  : 41,
                        'DEBUG'   : 40,
                        'VERBOSE' : 30,
                        'INFO'    : 20,
                        'WARN'    : 10,
                        'ERROR'   :  0,
                        }
        if isinstance(logfile, file):
            self.logfile = logfile
        else:
            try:
                self.logfile = open(logfile, 'a')
            except IOError, e:
                print >> sys.stderr, "EROR: can't open logfile %s for write, %s" % (logfile, e)
                print >> sys.stderr, "      using STDERR instead."
                self.logfile = sys.stderr

        if self.level not in self.loglevel:
            print >> self.logfile, "unknown loglevel: %s" % self.level
            sys.exit(1)

    def info(self, msg):
        if self.loglevel[self.level] >= self.loglevel['INFO']:
            print >> self.logfile, "INFO : %s" % msg.encode('utf-8')
            self.logfile.flush()

    def verbose(self, msg):
        if self.loglevel[self.level] >= self.loglevel['VERBOSE']:
            print >> self.logfile, "VERBO: %s" % msg.encode('utf-8')
            self.logfile.flush()

    def error(self, msg):
        if self.loglevel[self.level] >= self.loglevel['ERROR']:
            print >> self.logfile, "ERROR: %s" % msg.encode('utf-8')
            self.logfile.flush()

    def warn(self, msg):
        if self.loglevel[self.level] >= self.loglevel['WARN']:
            print >> self.logfile, "WARN : %s" % msg.encode('utf-8')
            self.logfile.flush()

    def debug(self, msg):
        if self.loglevel[self.level] >= self.loglevel['DEBUG']:
            print >> self.logfile, "DEBUG: %s" % msg.encode('utf-8')
            self.logfile.flush()

    def debug1(self, msg):
        if self.loglevel[self.level] >= self.loglevel['DEBUG1']:
            print >> self.logfile, "debug(1): %s" % msg.encode('utf-8')
            self.logfile.flush()

    def debug2(self, msg):
        if self.loglevel[self.level] >= self.loglevel['DEBUG2']:
            print >> self.logfile, "debug(2): %s" % msg.encode('utf-8')
            self.logfile.flush()

    def debug3(self, msg):
        if self.loglevel[self.level] >= self.loglevel['DEBUG3']:
            print >> self.logfile, "debug(3): %s" % msg.encode('utf-8')
            self.logfile.flush()

    def debug4(self, msg):
        if self.loglevel[self.level] >= self.loglevel['DEBUG4']:
            print >> self.logfile, "debug(4): %s" % msg.encode('utf-8')
            self.logfile.flush()

    def debug5(self, msg):
        if self.loglevel[self.level] >= self.loglevel['DEBUG5']:
            print >> self.logfile, "debug(5): %s" % msg.encode('utf-8')
            self.logfile.flush()
